<?php
/*
    PmWiki
    Copyright 2001-2002 Patrick R. Michaud 
    pmichaud@pobox.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#$errlevel = error_reporting(); error_reporting($errlevel|E_NOTICE);
$UnsafeGlobals = array_keys($GLOBALS);
$Version = "pmwiki-0.3";
$WikiTitle = "PmWiki";
$DefaultGroup = "Main";
$DefaultTitle = "HomePage";
$ScriptUrl = $HTTP_SERVER_VARS['SCRIPT_NAME'];
$ScriptDir = preg_replace("#/[^/]*\$#","",$ScriptUrl,1);
$WikiImgUrl = "$ScriptDir/pmwiki-50.gif";
$DiffKeepDays = 3650;
$WikiDir = "wiki.d";
$BodyWidth = 600;
$BodyLeft = 20;
$DeleteKeyWord = "delete";
$TimeFmt = "%B %d, %Y, at %l:%M %P";
$AuthRealmFmt = '$WikiTitle - $Group';
$AuthDeniedFmt = 'A valid password is required to access this feature.';
$DefaultPageTextFmt = 'Describe $Title here.';
$GroupHeaderFmt = '$Group.GroupHeader';
$GroupAttributesFmt = '$Group.GroupAttributes';
$HTMLStartFmt = 
  "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" 
    \"http://www.w3.org/TR/html40/loose.dtd\">
  <html><head>";
$HTMLTitleFmt = "<title>\$WikiTitle - \$HTMLTitle</title>";
$HTMLHeaderFmt = "<style type='text/css'>
  HR { width:\$BodyWidthpx; text-align:left; }
  .wikiheader { font-size:32px; font-weight:bold; }
  .wikiops, .wikifooter { font-size:13px; }
  .wikibody { margin-left:\$BodyLeftpx; width:\$BodyWidthpx; }
  .revdate { font-family:verdana; font-size:11px; }
  .revtype { font-family:verdana; font-size:11px; font-weight:bold; }
  .revadd { background:#99ff99; }
  .revdel { background:#ffff99; }
</style>";
$HTMLEndFmt = "</div></body></html>";
$HTMLBodyFmt = "</head><body bgcolor='#ffffff'><div class='wikibody'>";
$PageFileFmt = '$Group.$Title';
$PageNameFmt = '$Group.$Title';
$PageUrlFmt = '$ScriptUrl/$Group/$Title';
$PageHeaderFmt = "
  <table width='\$BodyWidth' cellpadding='0' cellspacing='0' border='0'>
  <tr><td valign='bottom' align='left' class='wikiheader'>\$WikiImg
      <a href='\$ScriptUrl?action=search&amp;text=\$Title'>\$Title</a></td>
    <td valign='bottom' align='right' class='wikiops'>
      <a href='\$ScriptUrl/Main/SearchWiki'>SearchWiki</a><br>
      <a href='\$ScriptUrl/\$Group/RecentChanges'>\$Group.RecentChanges</a><br>
      <a href='$PageUrlFmt?action=edit'>Edit Page</a><br>
      <a href='$PageUrlFmt?action=diff'>Page Revisions</a></td>
   </tr></table><hr><p>";
$PageFooterFmt = "<hr><small>
  <a href='$PageUrlFmt?action=edit'>Edit Page</a> - 
  <a href='$PageUrlFmt?action=diff'>Page Revisions</a> -
  <a href='\$ScriptUrl/Main/WikiHelp'>WikiHelp</a> -
  <a href='\$ScriptUrl/Main/SearchWiki'>SearchWiki</a> -
  <a href='\$ScriptUrl/\$Group/RecentChanges'>RecentChanges</a><br>
  Page last modified on \$LastModified</small>";
$PageEditFmt = "<form action='\$ScriptUrl' method='post'>
  <input type='hidden' name='pagename' value='$PageNameFmt'>
  <input type='hidden' name='action' value='post'>
  <h1>\$Group.\$Title
    <input type='submit' value=' Save '>
    <input type='reset' value=' Reset '></h1>
  <p><a href='\$ScriptUrl/Main/TipsForEditing'>TipsForEditing</a>
    <a href='\$ScriptUrl/Main/TextFormattingRules'>TextFormattingRules</a>
  <p><textarea name='text' rows='25' cols='80'
    wrap='virtual'>\$Text</textarea><br></form>";
$PageSearchFmt = "<h1>\$WikiImg Search
  Results</h1>Searching for <em>\$Needle</em>:<p><ol>\$MatchList</ol>
  <p>\$MatchCount pages found out of \$MatchSearched pages searched.
  <hr><small>
  <a href='\$ScriptUrl/Main/WikiHelp'>WikiHelp</a> -
  <a href='\$ScriptUrl/Main/SearchWiki'>SearchWiki</a> -
  <a href='\$ScriptUrl/\$Group/RecentChanges'>RecentChanges</a><br>
  Search performed on \$LastModified</small>";
$SearchListItemFmt = "<li><a href='$PageUrlFmt'>$PageNameFmt</a>\n";
$TableAttr = "";
$Umask = 002;
  
$WikiWordPattern = "[A-Z][A-Za-z0-9]*(?:[A-Z][a-z0-9]|[a-z0-9][A-Z])[A-Za-z0-9]*";
$GroupNamePattern = "[A-Z][A-Za-z0-9]+";
$PageNamePattern="($GroupNamePattern)([.\\/])($WikiWordPattern)";
$UrlPathPattern="[^\\s<>[\\]\"\'()]*[^\\s<>[\\]\"\'(),.?]";
$UrlMethodPattern="http|ftp|mailto|news|file|gopher|nap|https";
$UrlPattern="($UrlMethodPattern):($UrlPathPattern)";
$InterMapFiles=array('intermap.txt','localmap.txt');
$MapPatterns=array();
$Now = time(); 
$RedirectDelay = 0;
$DefaultPasswords = array('admin'=>'*','attr'=>'*','edit'=>'','read'=>'');
$MaxIncludes = 10;
$SearchFmt = "<form action='\$ScriptUrl' method='post'><input type='hidden' name='action' value='search'><input type='text' name='text' value='' size='30'><input type='submit' value='Search'></form>";
$DoubleBrackets = array('[[$Group]]'=>'$Group', '[[$Title]]'=>'$Title',
  '[[$Groupspaced]]'=>'$Groupspaced','[[$Titlespaced]]'=>'$Titlespaced',
  '[[noheader]]'=>'','[[nofooter]]'=>'','[[nogroupheader]]'=>'',
  '[[notitle]]'=>'',
  '[[spacewikiwords]]'=>'',
  '[[$Search]]'=>$SearchFmt,
  '[[$LastModified]]'=>'$LastModified','[[$Version]]'=>'$Version',
  '[[$DefaultGroup]]'=>'$DefaultGroup',
  '[[$Edit' => '[[http:$ScriptUrl/$Group/$Title?action=edit ',
  '[[$Diff' => '[[http:$ScriptUrl/$Group/$Title?action=diff ');
$InlineReplacements = array(
  "/'''(.*?)'''/" => "<strong>\$1</strong>",
  "/''(.*?)''/" => "<em>\$1</em>",
  "/@@(.*?)@@/" => "<code>\$1</code>",
  "/\\[\\[&lt;&lt;\\]\\]/" => "<br clear='all'>",
  "/\\[(([-+])+)(.*?)\\1\\]/e" => 
    "'<font size=\'\$2'.strlen('\$1').'\'>'.str_replace('\\\"','\"','$3').'</font>'",
  "/^----+/" => "<hr>");
$RecentChanges = array(
  "Main.AllRecentChanges"=>'$Group.$Title',
  '$Group.RecentChanges'=>'$Title');

$Newline = "\262";
$KeepToken = "\263";
$IPToken = "\264";

$gvars = array('pagename','action','text');
foreach($gvars as $v) {
  if (isset($HTTP_GET_VARS[$v])) $$v=$HTTP_GET_VARS[$v];
  elseif (isset($HTTP_POST_VARS[$v])) $v=$HTTP_POST_VARS[$v];
}

if (!isset($pagename) || $pagename=="") 
  $pagename=@substr($HTTP_SERVER_VARS['PATH_INFO'],1);
if (!isset($action)) $action='browse';

if (file_exists('local.php')) { include('local.php'); $LocalConf=1; }

umask($Umask);
if (!is_dir($WikiDir)) 
  { mkdir ($WikiDir,0777) or Abort("Cannot create $WikiDir"); }
if (!isset($UrlPattern)) 
  $UrlPattern = "($UrlMethodPattern):($UrlPathPattern)";
if (!isset($DefaultPage)) $DefaultPage="$DefaultGroup.$DefaultTitle";
if (!isset($WikiImg)) 
  $WikiImg="<a href='$ScriptUrl/$DefaultPage'><img src='$WikiImgUrl' 
    alt='$WikiTitle' border='0'></a>";
if (!isset($WikiLibDirs)) $WikiLibDirs=array($WikiDir,"wikilib.d");
foreach($InterMapFiles as $mapfile) {
  if (@!($mapfd=fopen($mapfile,"r"))) continue;
  while ($mapline=fgets($mapfd,1024)) {
    if (preg_match("/^\\s*\$/",$mapline)) continue;
    list($mapid,$mapurl) = preg_split("/\\s+/",$mapline);
    $MapPatterns["$mapid:($UrlPathPattern)"]=$mapurl;
  }
  fclose($mapfd);
}
$LastModified = strftime($TimeFmt,$Now);


if ($action=="crypt") { HandleCrypt(); exit; }
elseif ($action=="search") { HandleSearch($text); exit; }

if (!preg_match("/^$PageNamePattern\$/",$pagename)) {
  if (preg_match("/^($GroupNamePattern)([.\\/])?$/",$pagename,$match)) { 
     $pagename = $match[1].'.'.$match[1];
     if (!PageExists($pagename)) $pagename=$match[1].".$DefaultTitle";
  }
  if (!PageExists($pagename))  $pagename=$DefaultPage; 
  Redirect($pagename);
}
$pagename=FmtPageName($PageNameFmt,$pagename);

if ($action=="edit") HandleEdit($pagename);
elseif ($action=="post") HandlePost($pagename);
elseif ($action=="attr") HandleAttr($pagename);
elseif ($action=="postattr") HandlePostAttr($pagename);
elseif ($action=="source") HandleSource($pagename);
elseif ($action=="diff") HandleDiff($pagename);
else { $action=="browse"; HandleBrowse($pagename); }
EndHTML();
Lock(-1);


function Abort($msg) {
  StartHTML("Program error");
  echo("<h3>PmWiki can't process your request</h3>
    $msg<p>We are sorry for any inconvenience.");
  echo("<p>Current Directory is: ".getcwd());
  EndHTML();
  exit();
}

function StartHTML($title = "",$pagename = NULL) {
  global $calledStartHTML; if ($calledStartHTML++) return;
  global $HTMLStartFmt,$HTMLTitleFmt,$HTMLHeaderFmt,$HTMLBodyFmt;
  header("Expires: Tue, 01 Jan 2002 00:00:00 GMT");
  header("Last-Modified: ".gmstrftime('%a, %d %b %Y %H:%M:%S GMT'));
  header("Cache-Control: no-store, no-cache, must-revalidate");
  header("Cache-Control: post-check=0, pre-check=0", false);
  echo str_replace('$HTMLTitle',$title,FmtPageName($HTMLStartFmt.
    $HTMLTitleFmt.$HTMLHeaderFmt.$HTMLBodyFmt,$pagename));
}

function EndHTML($pagename=NULL) {
  static $called; if ($called++) return;
  global $calledStartHTML,$HTMLEndFmt;
  if ($calledStartHTML) echo FmtPageName($HTMLEndFmt,$pagename);
}

function Redirect($pagename) {
  global $RedirectDelay,$ScriptUrl,$DefaultPage,$PageUrlFmt;
  clearstatcache();
  if (!PageExists($pagename)) $pagename=$DefaultPage;
  $pageurl=FmtPageName($PageUrlFmt,$pagename);
  header("Location: $pageurl");
  exit;
}

function EncodeNewline($str) 
  { return str_replace("\n",$GLOBALS["Newline"],$str); }

function AsSpaced($word) {
  $word = preg_replace("/([a-z0-9])([A-Z])/","\$1 \$2",$word);
  return preg_replace("/([A-Z])([A-Z][a-z0-9])/","\$1 \$2",$word);
}

function FmtPageName($fmt,$pagename) {
  global $PageNamePattern,$UnsafeGlobals;
  static $g;
  static $qk = 
    array('$Titlespaced','$Title','$Groupspaced','$Group','$ScriptUrl');
  if (!is_null($pagename) && 
    !preg_match("/^$PageNamePattern\$/",$pagename,$match)) return "";
  $qv = @array(AsSpaced($match[3]),$match[3],AsSpaced($match[1]),$match[1],
    $GLOBALS['ScriptUrl']);
  if (phpversion()>="4.0.5") $fmt=str_replace($qk,$qv,$fmt);
  else for($i=0;$i<5;$i++) $fmt=str_replace($qk[$i],$qv[$i],$fmt);
  if (strpos($fmt,'$')===false) return $fmt;
  if (count($g)!=count($GLOBALS)-count($UnsafeGlobals)) {
    foreach($GLOBALS as $n=>$v) {
      if (in_array($n,$UnsafeGlobals)) continue;
      if (is_array($v)) { $UnsafeGlobals[]=$n; continue; }
      $g["\$$n"]=$v;
    }
    krsort($g); reset($g);
  }
  if (isset($g[$fmt])) return $g[$fmt];
  if (phpversion()>="4.0.5") 
    return str_replace(array_keys($g),array_values($g),$fmt);
  foreach($g as $n=>$v) $fmt=str_replace($n,$v,$fmt);
  return $fmt;
}

function Diff($oldtext,$newtext) {
  global $WikiDir,$Newline;
  $tempold = tempnam($WikiDir,"old");
  if ($oldfp = fopen($tempold,"w")) { 
    fputs($oldfp,str_replace($Newline,"\n",$oldtext)); 
    fclose($oldfp); 
  }
  $tempnew = tempnam($WikiDir,"new");
  if ($newfp = fopen($tempnew,"w")) { 
    fputs($newfp,str_replace($Newline,"\n",$newtext)); 
    fclose($newfp); 
  }
  $diff = `/usr/bin/diff $tempold $tempnew`;
  @unlink($tempold); @unlink($tempnew);
  return $diff;
}

function PageExists($pagename) {
  global $WikiLibDirs,$PageFileFmt;
  $pagefile = FmtPageName($PageFileFmt,$pagename);
  if (!$pagefile) return false;
  foreach ($WikiLibDirs as $dir) {
    if (file_exists("$dir/$pagefile")) return true;
  }
  return false;
}
    
function Lock($op) {
  global $WikiDir;
  static $lockfp,$curop;
  if (!$lockfp) {
    $lockfp=fopen("$WikiDir/.flock","w") or Abort("Cannot acquire lockfile");
  }
  if ($op<0) { flock($lockfp,LOCK_UN); fclose($lockfp); $lockfp=0; $curop=0; }
  elseif ($op==0) { flock($lockfp,LOCK_UN); $curop=0; }
  elseif ($op==1 && $curop<1) { flock($lockfp,LOCK_SH); $curop=1; }
  elseif ($op==2 && $curop<2) { flock($lockfp,LOCK_EX); $curop=2; }
}

function ReadPage($pagename,$defaulttext=NULL) {
  global $WikiLibDirs,$PageFileFmt,$DefaultPageTextFmt,$Now,$TimeFmt;
  $pagefile = FmtPageName($PageFileFmt,$pagename);
  if (!$pagefile) return false;
  if (is_null($defaulttext)) $defaulttext=$DefaultPageTextFmt;
  $page["text"] = FmtPageName($defaulttext,$pagename);
  $page["time"] = $Now;
  Lock(1);
  foreach ($WikiLibDirs as $dir) {
    $fp = @fopen("$dir/$pagefile","r");
    if ($fp) break;
  }
  if ($fp) {
    while (!feof($fp)) {
      $line = fgets($fp,4096);
      while (!strstr($line,"\n") && !feof($fp)) { $line .= fgets($fp,4096); }
      @list($k,$v) = explode("=",rtrim($line),2);
      $page[$k] = $v;
    }
    fclose($fp);
  }
  $page['timefmt'] = strftime($TimeFmt,$page['time']);
  return $page;
}

function WritePage($pagename,$page) {
  global $Now,$HTTP_SERVER_VARS,$WikiDir,$PageFileFmt,$Version;
  Lock(2);
  foreach (array('timefmt','pagename','action','version') as $k)
    unset($page[$k]);
  $page['time'] = $Now; 
  $page['host'] = $HTTP_SERVER_VARS['REMOTE_ADDR'];
  $page['agent'] = $HTTP_SERVER_VARS['HTTP_USER_AGENT'];
  $page['rev'] = $page['rev']+1;
  $pagefile = FmtPageName($PageFileFmt,$pagename);
  if ($pagefile && ($fp=fopen("$WikiDir/$pagefile","w"))) {
    fputs($fp,"version=$Version\n");
    foreach($page as $k=>$v) 
      { if ($k>"") fputs($fp,EncodeNewline("$k=$v")."\n"); }
    fclose($fp);
  } else Abort("Cannot write text to $pagename ($pagefile)"); 
}  

function Anchor($ref,$pagename,$imgalign=">") {
  global $UrlPattern,$MapPatterns,$PageNamePattern,$PageUrlFmt,
    $WikiWordPattern,$SpaceWikiWords;
  static $refcount;
  if (preg_match("/^mailto:(.*)\$/",$ref,$match)) {
    return "<a href='$ref'>$match[1]</a>";
  }
  if (preg_match("/^\\[\\[([^ ]+)( .*)?\\]\\]\$/",$ref,$match)) { 
    $bref=$match[1]; 
    if ($match[2]=="") { $refcount++; $btext="[$refcount]"; }
    else $btext=ltrim($match[2]); 
  } else { $bref=$ref; $btext=$ref; }
  foreach ($MapPatterns as $pat=>$url) {
    if (preg_match("/^$pat\$/",$bref,$match)) $bref=$url.$match[1];
  }
  if (preg_match("/\\.(gif|jpg|jpeg|png)\$/",$btext)) {
    $bimg = $btext;
    foreach($MapPatterns as $pat=>$url) {
      if (preg_match("/^$pat\$/",$bimg,$match)) $bimg=$url.$match[1];
    }
    if (preg_match("/^$UrlPattern\$/",$bimg))
      $btext="<img src='$bimg' alt='$btext' border='0'".$imgalign;
    if ($ref[0]!='[') return $btext;
  }
  if (preg_match("/^$UrlPattern\$/",$bref)) 
    { return "<a href='$bref'>$btext</a>"; }
  if (!preg_match("/^$PageNamePattern\$/",$bref)) {
    $bref = FmtPageName('$Group',$pagename).".$bref";
  }
  if ($ref[0]!='[') {
    $btext=preg_replace("/^.*\//","",$btext);
    if ($SpaceWikiWords && preg_match("/^$WikiWordPattern\$/",$btext))
      $btext=AsSpaced($btext);
  }
  $burl = FmtPageName($PageUrlFmt,$bref);
  if (PageExists($bref)) return "<a href='$burl'>$btext</a>";
  return "$btext<a href='$burl?action=edit'>?</a>";
}

function EmitCode($code,$depth,$attr="") {
  static $cs;
  if (!$cs) { $cs = array(); }
  if ($cs[0]=='TABLE' && $code!=$cs[0]) 
    while (count($cs)>0) { echo "</",array_pop($cs),">"; }
  if ($code=='P') { echo "<$code>"; return; }
  if ($cs[0]=='PRE' && $code!=$cs[0]) 
    while (count($cs)>0) { echo "</",array_pop($cs),">"; }
  while (count($cs)>$depth) { echo "</",array_pop($cs),">"; }
  while (count($cs)<$depth) { array_push($cs,$code); echo "<$code $attr>"; }
  if ($depth>0 && $cs[$depth-1] != $code) 
    { echo "</",array_pop($cs),"><$code $attr>"; array_push($cs,$code); }
}

function FormatTableRow($x) {
  $x = preg_replace("/\\|\\|\$/","",$x);
  $td = explode('||',$x); $y='';
  for($i=0;$i<count($td);$i++) {
    if ($td[$i]=="") continue;
    if (preg_match("/^\\s+\$/",$td[$i])) $td[$i]="&nbsp;";
    $attr=" valign='top'";
    if (preg_match("/^\\s.*\\s\$/",$td[$i])) { $attr .= " align='center'"; }
    elseif (preg_match("/^\\s/",$td[$i])) { $attr .= " align='right'"; }
    for($colspan=1;$i+$colspan<count($td);$colspan++) 
      if ($td[$colspan+$i] != "") break;
    if ($colspan>1) { $attr .= " colspan='$colspan'"; }
    $y .= "<td$attr>".$td[$i]."</td>";
  }
  return "<tr>$y</tr>";
}

function PrintText($pagename,$text) {
  global $Newline,$KeepToken,$IPToken,$UrlPattern,$MapPatterns,
    $PageNamePattern,$WikiWordPattern,$DoubleBrackets,$TableAttr,
    $InlineReplacements;
  $kp=$KeepToken; $ip=$IPToken;
  $text = htmlspecialchars($text,ENT_NOQUOTES);
  $text = str_replace($Newline,"\n",$text);
  $text = str_replace("\\\n"," ",$text);
  $kpcount=0;
  while (preg_match("/\\[\\=(.*?)\\=\\]/s",$text,$match)) {
    $text = preg_replace("/\\[\\=(.*?)\\=\\]/s","$kp$kpcount$kp",$text,1);
    $kpv[$kpcount] = $match[1]; $kpcount++;
  }
  foreach($DoubleBrackets as $n=>$fmt) {
    if ($n[0]!='/') $text=str_replace($n,FmtPageName($fmt,$pagename),$text);
  }
  $lines = explode("\n",$text);
  $ippats = array_merge($UrlPattern,array_keys($MapPatterns),
    $PageNamePattern,$WikiWordPattern);
  foreach($lines as $x) {
    foreach($DoubleBrackets as $n=>$fmt) {
      if ($n[0]=='/') $x=preg_replace($n,$fmt,$x);
    }
    $ipcount = 0;
    $ipv = array();
    foreach($ippats as $pat) {
      $re = "/(\\[\\[($pat)( .*?)?\\]\\])/";
      while(preg_match($re,$x,$match)) {
        $x=preg_replace($re,"$ip$ipcount$ip",$x,1);
        $ipv[$ipcount++] = $match[0];
      }
    }
    foreach($ippats as $pat) {
      $re = "/\\b($pat)/";
      while(preg_match($re,$x,$match)) {
        $x=preg_replace($re,"$ip$ipcount$ip",$x,1);
        $ipv[$ipcount++] = $match[0];
      }
    }
    if (preg_match("/^\\s*\$/",$x)) {
      EmitCode("P",0); continue;
    } elseif (preg_match("/^(:+)[^:]*:/",$x,$match)) {
      $x=preg_replace("/^:+([^:]*):/","<dt>\\1</dt><dd>",$x);
      EmitCode("DL",strlen($match[1]));
    } elseif (preg_match("/^(\\*+)/",$x,$match)) {
      $x=preg_replace("/^\\*+/","<li>",$x);
      EmitCode("UL",strlen($match[1]));
    } elseif (preg_match("/^(#+)/",$x,$match)) {
      $x=preg_replace("/^#+/","<li>",$x);
      EmitCode("OL",strlen($match[1]));
    } elseif (preg_match("/^\s/",$x)) {
      EmitCode("PRE",1);
    } elseif (preg_match("/^\\|\\|.*\\|\\|/",$x,$match)) {
      EmitCode("TABLE",1,$TableAttr);
      $x=FormatTableRow($x);
    } elseif (preg_match("/^\\|\\|(.*)/",$x,$match)) {
      EmitCode("",0);
      $TableAttr = $match[1];
      continue;
    } elseif (preg_match("/^(!+)/",$x,$match)) {
      $h="h".strlen($match[1]);
      $x=preg_replace("/^(!+)/","<$h>",$x)."</$h>";
      EmitCode("",0);
    } else EmitCode("",0);
    foreach ($InlineReplacements as $pat => $rep) 
      $x = preg_replace($pat,$rep,$x);
    if (preg_match("/^\\s*($ip(\\d+)$ip)\\s*\$/",$x,$match))
      $x = Anchor($ipv[$match[2]],$pagename,"><br>");
    if (preg_match("/^\\s*($ip(\\d+)$ip).*\\S/",$x,$match)) 
      $x = str_replace($match[1],
        Anchor($ipv[$match[2]],$pagename," align='left'>"),$x);
    if (preg_match("/\\S.*($ip(\\d+)$ip)\\s*\$/",$x,$match)) {
      $rt = Anchor($ipv[$match[2]],$pagename," align='right'>");
      if (strstr($rt,"<img")) $x=$rt.str_replace($match[1],"",$x);
      else $x=str_replace($match[1],$rt,$x);
    }
    $x = preg_replace("/$ip(\\d+)$ip/e",'Anchor($ipv[$1],$pagename)',$x);
    $x = preg_replace("/$kp(\\d+)$kp/e",'$kpv[$1]',$x);
    echo $x,"\n";
  }
  EmitCode("",0);
}

function HandleBrowse($pagename) {
  global $PageNamePattern,$GroupHeaderFmt,$LastModified,
    $PageHeaderFmt,$PageTitleFmt,$PageFooterFmt,$MaxIncludes,$SpaceWikiWords;
  $page = RetrieveAuthPage($pagename,"read"); 
  if (!$page) { Abort("Invalid page name"); }
  $LastModified = $page['timefmt'];
  $inclcount=0;
  while ($inclcount<$MaxIncludes &&
      preg_match("/\\[\\[include:(.*?)\\]\\]/",$page['text'],$match)) {
    $inclname=$match[1]; $incltext='';
    if (!preg_match("/^$PageNamePattern\$/",$inclname))
      $inclname = FmtPageName('$Group',$pagename).".$inclname";
    $inclpage = RetrieveAuthPage($inclname,"read",false);
    if ($inclpage) $incltext=$inclpage['text'];
    $page['text'] = preg_replace("/\\[\\[include:(.*?)\\]\\]/",
      $incltext,$page['text'],1);
    $inclcount++;
  }
  if (!strstr($page['text'],"[[nogroupheader]]")) {
    $hdname = FmtPageName($GroupHeaderFmt,$pagename);
    if ($hdname != $pagename) { 
      $hdpage=ReadPage($hdname,""); 
      $page['text'] = $hdpage['text'].$page['text'];
    }
  }
  Lock(0);
  if (function_exists($PageHeaderFmt)) $PageHeaderFmt($pagename,$page);
  else {
    StartHTML($pagename,$pagename);
    if (!strstr($page['text'],'[[noheader]]')) 
      echo FmtPageName($PageHeaderFmt,$pagename); 
  }
  if (function_exists($PageTitleFmt)) $PageTitleFmt($pagename,$page);
  else if (!strstr($page['text'],'[[notitle]]'))
    echo FmtPageName($PageTitleFmt,$pagename);
  if (strstr($page['text'],'[[spacewikiwords]]')) $SpaceWikiWords=1;
  PrintText($pagename,$page['text']);
  if (!strstr($page['text'],"[[nofooter]]")) {
    if (function_exists($PageFooterFmt)) $PageFooterFmt($pagename,$page);
    else echo FmtPageName($PageFooterFmt,$pagename);
  }
  EndHTML();
}

function HandleEdit($pagename) {
  global $Newline,$PageEditFmt;
  $page = RetrieveAuthPage($pagename,"edit");
  if (!$page) { Abort("?cannot edit $pagename"); }
  $text = $page['text'];
  $text = str_replace($Newline,"\n",$text);
  $text = htmlspecialchars($text,ENT_NOQUOTES);
  if (function_exists($PageEditFmt)) { $PageEditFmt($pagename,$page); }
  else { 
    StartHTML("Edit $pagename",$pagename); 
    echo str_replace('$Text',$text,FmtPageName($PageEditFmt,$pagename));
  }
  EndHTML();
}

function HandlePost($pagename) {
  global $WikiDir,$DeleteKeyWord,$RecentChanges,$HTTP_POST_VARS,$Now,
    $TimeFmt,$PageNameFmt,$PageFileFmt,$Newline,$DiffKeepDays;
  foreach($HTTP_POST_VARS as $k=>$v)
    { $new[$k]=str_replace("\r","",stripslashes($HTTP_POST_VARS[$k])); }
  Lock(2);
  $page = RetrieveAuthPage($pagename,"edit");
  if (!$page) { Abort("?cannot post $pagename"); }
  $pagename = FmtPageName($PageNameFmt,$pagename);
  if ($page["time"]>0) 
    { $new["diff:$Now:".$page['time']] = Diff($new["text"],$page["text"]); }
  foreach($new as $k=>$v) {
    if ($k=='pagename' || $k=='action') continue;
    $page[$k] = $v;
  }
  $keepgmt = $Now-$DiffKeepDays*86400;
  $keys = array_keys($page);
  foreach ($keys as $k) 
    if (preg_match("/^diff:(\\d+):/",$k,$match))
      if ($match[1] < $keepgmt) unset($page[$k]);
  $pagefile = FmtPageName($PageFileFmt,$pagename);
  if ($page['text']==$DeleteKeyWord) 
    { @rename("$WikiDir/$pagefile","$WikiDir/$pagefile-$Now"); }
  else WritePage($pagename,$page);
  foreach($RecentChanges as $rcfmt => $pgfmt) {
    $rcname=FmtPageName($rcfmt,$pagename); if (!$rcname) continue;
    $pgname=FmtPageName($pgfmt,$pagename); if (!$pgname) continue;
    if (@$seen[$rcname]++) continue;
    $rcpage = ReadPage($rcname,"");
    $rcpage['text'] = "* $pgname . . . . . . ".strftime($TimeFmt,$Now)."\n".
      preg_replace("/\\* $pgname .*?$Newline/","",$rcpage['text']);
    WritePage($rcname,$rcpage);
  }
  Redirect($pagename); 
}

function HandleSearch($needle) {
  global $WikiLibDirs,$SearchListItemFmt,$PageSearchFmt;
  $matches = array(); $matchsearched=0;
  if ($needle=="") $needle=" ";
  foreach($WikiLibDirs as $dir) {
    $dfp=opendir($dir); if (!$dfp) continue;
    while (($pagefile=readdir($dfp))!=false) {
      if (@$seen[$pagefile]++) continue;
      $page=ReadPage($pagefile); if (!$page) continue;
      $matchsearched++;
      if (stristr($pagefile,$needle) || stristr($page['text'],$needle)) 
        { $matches[] =  $pagefile; }
    }
    closedir($dfp);
  }
  sort($matches); reset($matches);
  StartHTML("Search results");
  $MatchList = array();
  foreach($matches as $pagefile) 
    { $MatchList[] = FmtPageName($SearchListItemFmt,$pagefile); }
  $out = FmtPageName($PageSearchFmt,NULL);
  $out = str_replace('$MatchList',join('',$MatchList),$out);
  $out = str_replace('$MatchCount',count($matches),$out);
  $out = str_replace('$MatchSearched',$matchsearched,$out);
  $out = str_replace('$Needle',htmlspecialchars($needle),$out);
  echo $out;
  EndHTML();
}

function HandleSource($pagename) {
  global $Newline;
  $page = RetrieveAuthPage($pagename,"read");
  if (!$page) Abort("?cannot source $pagename");
  Lock(0);
  header("Content-Type: text/plain");
  $text = str_replace($Newline,"\n",$page['text']);
  echo $text;
}

function HandleDiff($pagename) {
  global $TimeFmt,$Newline;
  $page = RetrieveAuthPage($pagename,"read");
  if (!$page) { Abort("?cannot source $pagename"); }
  Lock(0);
  krsort($page); reset($page);
  StartHTML("$pagename Revisions",$pagename);
  echo "<h1>",Anchor($pagename,$pagename)," Revisions</h1>\n";
  foreach($page as $k=>$v) {
    if (!preg_match("/^diff:(\d+):(\d+)/",$k,$match)) continue;
    $gmt=$match[1];
    echo "<p><table width='100%' cellspacing='0' cellpadding='0' border='1'>\n";
    echo "<tr><td class='revdate'>",
      strftime($TimeFmt,$gmt),"</td></tr><tr><td><table width='100%'>\n";
    $difflines = explode($Newline,$v.$Newline);
    $in=array(); $out=array(); $dtype="";
    foreach ($difflines as $d) {
      if ($d[0]=='-' || $d[0]=='\\') continue;
      if ($d[0]=='<') { $out[]=substr($d,2); continue; }
      if ($d[0]=='>') { $in[]=substr($d,2); continue; }
      if (preg_match("/^(\\d+)(,(\\d+))?a\\d/",$dtype,$match)) {
        $l = (isset($match[3])) ? "s ".$match[1]."-".$match[3] : " ".$match[1];
        echo "<tr><td colspan='2' class='revtype'>Deleted line$l:</td></tr>\n";
        echo "<tr><td width='4' class='revdel'>&nbsp;</td><td>";
        PrintText($pagename,join($Newline,$in));
        echo "</td></tr>\n";
      } elseif (preg_match("/d(\\d+)(,(\\d+))?$/",$dtype,$match)) {
        $l = (isset($match[3])) ? "s ".$match[1]."-".$match[3] : " ".$match[1];
        echo "<tr><td colspan='2' class='revtype'>Added line$l:</td></tr>\n";
        echo "<tr><td width='4' class='revadd'>&nbsp;</td><td>";
        PrintText($pagename,join($Newline,$out));
        echo "</td></tr>\n";
      } elseif (preg_match("/c(\\d+)(,(\\d+))?$/",$dtype,$match)) {
        $l = (isset($match[3])) ? "s ".$match[1]."-".$match[3] : " ".$match[1];
        echo "<tr><td colspan='2' class='revtype'>Changed line$l 
	  from:</td></tr>\n";
        echo "<tr><td width='4' class='revdel'>&nbsp;</td><td>";
        PrintText($pagename,join($Newline,$in));
        echo "</td></tr>\n";
        echo "<tr><td colspan='2' class='revtype'>to:</td></tr>";
        echo "<tr><td width='4' class='revadd'>&nbsp;</td><td>";
        PrintText($pagename,join($Newline,$out));
        echo "</td></tr>\n";
      }
      $in=array(); $out=array(); $dtype=$d;
    }
    echo "</td></tr></table></td></tr></table>";
  }
  echo "<p><hr>Back to ",Anchor($pagename,$pagename);
  EndHTML();
}

function HandleCrypt() {
  global $HTTP_POST_VARS,$ScriptUrl;
  StartHTML("Encrypt Password");
  $passwd = @$HTTP_POST_VARS["passwd"];
  if ($passwd) { echo "<p>Encrypted password = ",crypt($passwd),"</p>"; }
  echo "<p><form action='$ScriptUrl' method='POST'>
    Enter password to encrypt: <input type='text' name='passwd' value=''>
    <input type='submit'>
    <input type='hidden' name='action' value='crypt'></form>";
  EndHTML();
}

function RetrieveAuthPage($pagename,$level,$authprompt=true) {
  global $HTTP_SERVER_VARS,$AuthRealmFmt,$AuthDeniedFmt,$DefaultPasswords,
    $GroupAttributesFmt;
  $page = ReadPage($pagename);
  if (!$page) { return false; }
  @$passwd = $page["passwd$level"];
  if ($passwd=="") { 
    $grouppg = ReadPage(FmtPageName($GroupAttributesFmt,$pagename));
    @$passwd = $grouppg["passwd$level"];
  }
  if ($passwd=="") { $passwd=$DefaultPasswords[$level]; }
  if ($passwd=="") return $page;
  foreach (array_merge($DefaultPasswords['admin'],$passwd) as $pw) 
    if (crypt($HTTP_SERVER_VARS['PHP_AUTH_PW'],$pw)==$pw) return $page;
  if (!$authprompt) return false;
  $realm=FmtPageName($AuthRealmFmt,$pagename);
  Header("WWW-Authenticate: Basic realm=\"$realm\"");
  Header("HTTP/1.0 401 Unauthorized");
  echo FmtPageName($AuthDeniedFmt,$pagename);
  exit;
}

function HandleAttr($pagename) {
  global $ScriptUrl;
  $page = RetrieveAuthPage($pagename,"attr");
  if (!$page) { Abort("Unable to read $pagename"); }
  StartHTML("Edit $pagename Attributes",$pagename);
  echo "<form action='$ScriptUrl' method='POST'>
    <input type='hidden' name='pagename' value='$pagename'>
    <input type='hidden' name='action' value='postattr'>
    <h1>$pagename Attributes</h1>
    <form action='$ScriptUrl' method='post'>
    <input type='hidden' name='action' value='postattr'>
    <input type='hidden' name='pagename' value='$pagename'>
    <p>Enter new passwords for this page below.  Leaving a field blank
    will leave the password unchanged.  To clear a password, enter 'clear'.
    <table>
      <tr><td>Set new read password:</td>
        <td><input type='text' name='passwdread' value=''></td></tr>
      <tr><td>Set new edit password:</td>
        <td><input type='text' name='passwdedit' value=''></td></tr>
      <tr><td>Set new attribute password:</td>
        <td><input type='text' name='passwdattr' value=''></td></tr>
    </table>
    <input type='submit'></form>";
  EndHTML();
}

function HandlePostAttr($pagename) {
  global $HTTP_POST_VARS;
  $page = RetrieveAuthPage($pagename,"attr");
  if (!$page) { Abort("?cannot get $pagename"); }
  foreach(array("passwdread","passwdedit","passwdattr") as $k) {
    $newpw = $HTTP_POST_VARS[$k];
    if ($newpw=="clear") unset($page[$k]);
    else if ($newpw>"") $page[$k]=crypt($newpw);
  }
  WritePage($pagename,$page);
  Redirect($pagename);
  exit;
}

?>
